#!/bin/bash

set -e
#set -x

tables="raw filter mangle nat"
cur_table=""

function dump_table()
{
  if [ ! -z "$1" ]; then
    echo "*$1"
    cat $(eval echo \$T${1})
    echo "COMMIT"
    rm -f T${1}
  fi
}

for t in $tables; do
  eval T${t}="$(mktemp -t $t.XXXXXXX)"
done

while [ $# -ne 0 ]; do
  if [ -f $1 ]; then
    while IFS= read -r line; do
      if [[ "$line" =~ \*($(echo $tables | sed 's/ /|/g'))$ ]]; then
        cur_table=${line:1}
      elif [ "$line" != "COMMIT" ]; then
        if [ ! -z "$cur_table" ]; then
            echo $line >> $(eval echo \$T${cur_table})
        fi
      fi
    done < $1
  fi
  shift
done

for t in $tables; do
  dump_table $t
done

